diff --git a/orocos_kdl/src/kinfam_io.hpp b/orocos_kdl/src/kinfam_io.hpp
index c677c20..a476e65 100644
--- a/orocos_kdl/src/kinfam_io.hpp
+++ b/orocos_kdl/src/kinfam_io.hpp
@@ -22,9 +22,6 @@
 #ifndef KDL_KINFAM_IO_HPP
 #define KDL_KINFAM_IO_HPP
 
-#include <iostream>
-#include <fstream>
-
 #include "joint.hpp"
 #include "segment.hpp"
 #include "chain.hpp"
@@ -32,26 +29,31 @@
 #include "jacobian.hpp"
 #include "tree.hpp"
 #include "jntspaceinertiamatrix.hpp"
+#include "kdl_export.hpp"
+
+#include <iostream>
+#include <fstream>
 
 namespace KDL {
-std::ostream& operator <<(std::ostream& os, const Joint& joint);
-std::istream& operator >>(std::istream& is, Joint& joint);
-std::ostream& operator <<(std::ostream& os, const Segment& segment);
-std::istream& operator >>(std::istream& is, Segment& segment);
-std::ostream& operator <<(std::ostream& os, const Chain& chain);
-std::istream& operator >>(std::istream& is, Chain& chain);
 
-std::ostream& operator <<(std::ostream& os, const Tree& tree);
-std::istream& operator >>(std::istream& is, Tree& tree);
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, const Joint& joint);
+KDL_EXPORT std::istream& operator >>(std::istream& is, Joint& joint);
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, const Segment& segment);
+KDL_EXPORT std::istream& operator >>(std::istream& is, Segment& segment);
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, const Chain& chain);
+KDL_EXPORT std::istream& operator >>(std::istream& is, Chain& chain);
+
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, const Tree& tree);
+KDL_EXPORT std::istream& operator >>(std::istream& is, Tree& tree);
 
-std::ostream& operator <<(std::ostream& os, SegmentMap::const_iterator it);
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, SegmentMap::const_iterator it);
 
-std::ostream& operator <<(std::ostream& os, const JntArray& array);
-std::istream& operator >>(std::istream& is, JntArray& array);
-std::ostream& operator <<(std::ostream& os, const Jacobian& jac);
-std::istream& operator >>(std::istream& is, Jacobian& jac);
-std::ostream& operator <<(std::ostream& os, const JntSpaceInertiaMatrix& jntspaceinertiamatrix);
-std::istream& operator >>(std::istream& is, JntSpaceInertiaMatrix& jntspaceinertiamatrix);
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, const JntArray& array);
+KDL_EXPORT std::istream& operator >>(std::istream& is, JntArray& array);
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, const Jacobian& jac);
+KDL_EXPORT std::istream& operator >>(std::istream& is, Jacobian& jac);
+KDL_EXPORT std::ostream& operator <<(std::ostream& os, const JntSpaceInertiaMatrix& jntspaceinertiamatrix);
+KDL_EXPORT std::istream& operator >>(std::istream& is, JntSpaceInertiaMatrix& jntspaceinertiamatrix);
 
     /*
 template<typename T>
diff --git a/orocos_kdl/src/path.hpp b/orocos_kdl/src/path.hpp
index 6cffae4..d25dd09 100644
--- a/orocos_kdl/src/path.hpp
+++ b/orocos_kdl/src/path.hpp
@@ -45,17 +45,16 @@
 #define KDL_MOTION_PATH_H
 
 #include "frames.hpp"
-
-#include <vector>
-
 #include "frames_io.hpp"
+#include "kdl_export.hpp"
+#include <vector>
 
 namespace KDL {
 
 /**
  * The specification of the path of a trajectory.
  */
-class Path
+class KDL_EXPORT Path
 	{
 	public:
 		enum IdentifierType {
diff --git a/orocos_kdl/src/path_circle.hpp b/orocos_kdl/src/path_circle.hpp
index 36166cf..374446e 100644
--- a/orocos_kdl/src/path_circle.hpp
+++ b/orocos_kdl/src/path_circle.hpp
@@ -47,7 +47,7 @@
 
 #include "path.hpp"
 #include "rotational_interpolation.hpp"
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -57,7 +57,7 @@ namespace KDL {
 	 * have been a better name though.
 	 * @ingroup Motion
 	 */
-class Path_Circle : public Path
+class KDL_EXPORT Path_Circle : public Path
 	{
 
 		// Orientatie gedeelte
diff --git a/orocos_kdl/src/path_composite.hpp b/orocos_kdl/src/path_composite.hpp
index 25466eb..e951a14 100644
--- a/orocos_kdl/src/path_composite.hpp
+++ b/orocos_kdl/src/path_composite.hpp
@@ -47,6 +47,7 @@
 #include "frames.hpp"
 #include "frames_io.hpp"
 #include "path.hpp"
+#include "kdl_export.hpp"
 #include <vector>
 
 namespace KDL {
@@ -66,7 +67,7 @@ namespace KDL {
 	  *
 	  * @ingroup Motion
 	  */
-	 class Path_Composite : public Path
+	 class KDL_EXPORT Path_Composite : public Path
 	{
 		typedef std::vector< std::pair<Path*,bool> > PathVector;
 		typedef std::vector<double>    DoubleVector;
diff --git a/orocos_kdl/src/path_cyclic_closed.hpp b/orocos_kdl/src/path_cyclic_closed.hpp
index 73f98bd..0e751b3 100644
--- a/orocos_kdl/src/path_cyclic_closed.hpp
+++ b/orocos_kdl/src/path_cyclic_closed.hpp
@@ -47,6 +47,7 @@
 #include "frames.hpp"
 #include "frames_io.hpp"
 #include "path.hpp"
+#include "kdl_export.hpp"
 #include <vector>
 
 
@@ -57,7 +58,7 @@ namespace KDL {
 	  * which is traversed a number of times.
 	  * @ingroup Motion
 	  */
-	 class Path_Cyclic_Closed : public Path
+	class KDL_EXPORT Path_Cyclic_Closed : public Path
 	{
 		int times;
 		Path* geom;
diff --git a/orocos_kdl/src/path_line.hpp b/orocos_kdl/src/path_line.hpp
index 548aaf4..d974a6e 100644
--- a/orocos_kdl/src/path_line.hpp
+++ b/orocos_kdl/src/path_line.hpp
@@ -47,6 +47,7 @@
 
 #include "path.hpp"
 #include "rotational_interpolation.hpp"
+#include "kdl_export.hpp"
 
 
 namespace KDL {
@@ -56,7 +57,7 @@ namespace KDL {
 	 * A path representing a line from A to B.
 	 * @ingroup Motion
 	 */
-class Path_Line : public Path
+class KDL_EXPORT Path_Line : public Path
 	{
 		// Orientatie gedeelte
 		RotationalInterpolation* orient;
diff --git a/orocos_kdl/src/path_point.hpp b/orocos_kdl/src/path_point.hpp
index 8045cb4..1d79cfd 100644
--- a/orocos_kdl/src/path_point.hpp
+++ b/orocos_kdl/src/path_point.hpp
@@ -48,7 +48,7 @@
 
 #include "path.hpp"
 #include "rotational_interpolation.hpp"
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -58,7 +58,7 @@ namespace KDL {
  * A Path consisting only of a point in space.
  * @ingroup Motion
  */
-class Path_Point : public Path
+class KDL_EXPORT Path_Point : public Path
 	{
 		Frame F_base_start;
 	public:
diff --git a/orocos_kdl/src/path_roundedcomposite.hpp b/orocos_kdl/src/path_roundedcomposite.hpp
index 79c2657..a8e1894 100644
--- a/orocos_kdl/src/path_roundedcomposite.hpp
+++ b/orocos_kdl/src/path_roundedcomposite.hpp
@@ -47,6 +47,7 @@
 #include "path.hpp"
 #include "path_composite.hpp"
 #include "rotational_interpolation.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -55,7 +56,7 @@ namespace KDL {
  *
  * @ingroup Motion
  */
-class Path_RoundedComposite : public Path
+class KDL_EXPORT Path_RoundedComposite : public Path
 	{
 		/** a Path_Composite is aggregated to hold the rounded trajectory
 		 * with circles and lines
diff --git a/orocos_kdl/src/rigidbodyinertia.hpp b/orocos_kdl/src/rigidbodyinertia.hpp
index 6bc8f5e..5c81188 100644
--- a/orocos_kdl/src/rigidbodyinertia.hpp
+++ b/orocos_kdl/src/rigidbodyinertia.hpp
@@ -23,8 +23,8 @@
 #define KDL_RIGIDBODYINERTIA_HPP
 
 #include "frames.hpp"
-
 #include "rotationalinertia.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
     
@@ -34,7 +34,7 @@ namespace KDL {
      *	The inertia is defined in a certain reference point and a certain reference base.
      *	The reference point does not have to coincide with the origin of the reference frame.
      */
-    class RigidBodyInertia{
+    class KDL_EXPORT RigidBodyInertia{
     public:
         
         /**
@@ -56,29 +56,29 @@ namespace KDL {
         /**
          * Scalar product: I_new = double * I_old
          */
-        friend RigidBodyInertia operator*(double a,const RigidBodyInertia& I);
+        KDL_EXPORT friend RigidBodyInertia operator*(double a,const RigidBodyInertia& I);
         /**
          * addition I: I_new = I_old1 + I_old2, make sure that I_old1
          * and I_old2 are expressed in the same reference frame/point,
          * otherwise the result is worth nothing
          */
-        friend RigidBodyInertia operator+(const RigidBodyInertia& Ia,const RigidBodyInertia& Ib);
+        KDL_EXPORT friend RigidBodyInertia operator+(const RigidBodyInertia& Ia,const RigidBodyInertia& Ib);
 
         /**
          * calculate spatial momentum: h = I*v
          * make sure that the twist v and the inertia are expressed in the same reference frame/point
          */
-        friend Wrench operator*(const RigidBodyInertia& I,const Twist& t);
+        KDL_EXPORT friend Wrench operator*(const RigidBodyInertia& I,const Twist& t);
 
         /**
          * Coordinate system transform Ia = T_a_b*Ib with T_a_b the frame from a to b.
          */
-        friend RigidBodyInertia operator*(const Frame& T,const RigidBodyInertia& I);
+        KDL_EXPORT friend RigidBodyInertia operator*(const Frame& T,const RigidBodyInertia& I);
         /**
          * Reference frame orientation change Ia = R_a_b*Ib with R_a_b
          * the rotation of b expressed in a
          */
-        friend RigidBodyInertia operator*(const Rotation& R,const RigidBodyInertia& I);
+        KDL_EXPORT friend RigidBodyInertia operator*(const Rotation& R,const RigidBodyInertia& I);
 
         /**
          * Reference point change with v the vector from the old to
diff --git a/orocos_kdl/src/rotational_interpolation.hpp b/orocos_kdl/src/rotational_interpolation.hpp
index ced4914..4b13241 100644
--- a/orocos_kdl/src/rotational_interpolation.hpp
+++ b/orocos_kdl/src/rotational_interpolation.hpp
@@ -46,6 +46,7 @@
 
 #include "frames.hpp"
 #include "frames_io.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -59,7 +60,7 @@ namespace KDL {
  *   object is responsible for setting these each time
  * @ingroup Motion
  */
-class RotationalInterpolation
+class KDL_EXPORT RotationalInterpolation
 	{
 	public:
 		/**
diff --git a/orocos_kdl/src/rotational_interpolation_sa.hpp b/orocos_kdl/src/rotational_interpolation_sa.hpp
index b8a2840..d4d0bed 100644
--- a/orocos_kdl/src/rotational_interpolation_sa.hpp
+++ b/orocos_kdl/src/rotational_interpolation_sa.hpp
@@ -47,6 +47,7 @@
 #include "frames.hpp"
 #include "frames_io.hpp"
 #include "rotational_interpolation.hpp"
+#include "kdl_export.hpp"
 
 
 namespace KDL {
@@ -60,7 +61,7 @@ namespace KDL {
 	  * to try to interpolate a 180 degrees rotation.
 	  * @ingroup Motion
 	  */
-class RotationalInterpolation_SingleAxis: public RotationalInterpolation
+class KDL_EXPORT RotationalInterpolation_SingleAxis: public RotationalInterpolation
 	{
 		Rotation R_base_start;
 		Rotation R_base_end;
diff --git a/orocos_kdl/src/rotationalinertia.hpp b/orocos_kdl/src/rotationalinertia.hpp
index a648392..0791d35 100644
--- a/orocos_kdl/src/rotationalinertia.hpp
+++ b/orocos_kdl/src/rotationalinertia.hpp
@@ -23,6 +23,7 @@
 #define KDL_ROTATIONALINERTIA_HPP
 
 #include "frames.hpp"
+#include "kdl_export.hpp"
 
 //------- class for only the Rotational Inertia --------
 
@@ -31,7 +32,7 @@ namespace KDL
     //Forward declaration
     class RigidBodyInertia;
 
-	class RotationalInertia{
+	class KDL_EXPORT RotationalInertia{
     public:
               
         explicit RotationalInertia(double Ixx=0,double Iyy=0,double Izz=0,double Ixy=0,double Ixz=0,double Iyz=0);
@@ -40,8 +41,8 @@ namespace KDL
             return RotationalInertia(0,0,0,0,0,0);
         };
 
-        friend RotationalInertia operator*(double a, const RotationalInertia& I);
-        friend RotationalInertia operator+(const RotationalInertia& Ia, const RotationalInertia& Ib);
+        KDL_EXPORT friend RotationalInertia operator*(double a, const RotationalInertia& I);
+        KDL_EXPORT friend RotationalInertia operator+(const RotationalInertia& Ia, const RotationalInertia& Ib);
 
         /**
          * This function calculates the angular momentum resulting from a rotational velocity omega
@@ -52,15 +53,15 @@ namespace KDL
 
         friend class RigidBodyInertia;
         ///Scalar product
-        friend RigidBodyInertia operator*(double a,const RigidBodyInertia& I);
+        KDL_EXPORT friend RigidBodyInertia operator*(double a,const RigidBodyInertia& I);
         ///addition
-        friend RigidBodyInertia operator+(const RigidBodyInertia& Ia,const RigidBodyInertia& Ib);
+        KDL_EXPORT friend RigidBodyInertia operator+(const RigidBodyInertia& Ia,const RigidBodyInertia& Ib);
         ///calculate spatial momentum
-        friend Wrench operator*(const RigidBodyInertia& I,const Twist& t);
+        KDL_EXPORT friend Wrench operator*(const RigidBodyInertia& I,const Twist& t);
         ///coordinate system transform Ia = T_a_b*Ib with T_a_b the frame from a to b
-        friend RigidBodyInertia operator*(const Frame& T,const RigidBodyInertia& I);
+        KDL_EXPORT friend RigidBodyInertia operator*(const Frame& T,const RigidBodyInertia& I);
         ///base frame orientation change Ia = R_a_b*Ib with R_a_b the rotation for frame from a to b
-        friend RigidBodyInertia operator*(const Rotation& R,const RigidBodyInertia& I);
+        KDL_EXPORT friend RigidBodyInertia operator*(const Rotation& R,const RigidBodyInertia& I);
 
         double data[9];
 	};
diff --git a/orocos_kdl/src/segment.hpp b/orocos_kdl/src/segment.hpp
index 2ea4666..ea88367 100644
--- a/orocos_kdl/src/segment.hpp
+++ b/orocos_kdl/src/segment.hpp
@@ -26,6 +26,7 @@
 #include "frames.hpp"
 #include "rigidbodyinertia.hpp"
 #include "joint.hpp"
+#include "kdl_export.hpp"
 #include <vector>
 
 namespace KDL {
@@ -43,7 +44,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class Segment {
+    class KDL_EXPORT Segment {
         friend class Chain;
     private:
         std::string name;
diff --git a/orocos_kdl/src/stiffness.hpp b/orocos_kdl/src/stiffness.hpp
index 907d86d..b32c3f2 100644
--- a/orocos_kdl/src/stiffness.hpp
+++ b/orocos_kdl/src/stiffness.hpp
@@ -22,7 +22,7 @@
 #ifndef KDL_STIFFNESS_H
 #define KDL_STIFFNESS_H
 #include "frames.hpp"
- 
+#include "kdl_export.hpp"
 
 namespace KDL {
 /**
@@ -33,7 +33,7 @@ namespace KDL {
  * first 3 elements are stiffness for translations
  * last  3 elements are stiffness for rotations.
  */
-class Stiffness {
+class KDL_EXPORT Stiffness {
     double data[6];
 public:
 	Stiffness() {
diff --git a/orocos_kdl/src/trajectory.hpp b/orocos_kdl/src/trajectory.hpp
index f633a0c..0fae899 100644
--- a/orocos_kdl/src/trajectory.hpp
+++ b/orocos_kdl/src/trajectory.hpp
@@ -61,21 +61,19 @@
 #include "frames_io.hpp"
 #include "path.hpp"
 #include "velocityprofile.hpp"
-
+#include "kdl_export.hpp"
 
 
 namespace KDL {
 
 
-
-
 	/**
 	 * An abstract class that implements
 	 * a trajectory contains a cartesian space trajectory and an underlying
 	 * velocity profile.
 	  * @ingroup Motion
 	 */
-	class Trajectory
+	class KDL_EXPORT Trajectory
 	{
 	public:
 		virtual double Duration() const = 0;
diff --git a/orocos_kdl/src/trajectory_composite.hpp b/orocos_kdl/src/trajectory_composite.hpp
index a110e39..e3c7b51 100644
--- a/orocos_kdl/src/trajectory_composite.hpp
+++ b/orocos_kdl/src/trajectory_composite.hpp
@@ -20,7 +20,7 @@
 #include "trajectory.hpp"
 #include "path_composite.hpp"
 #include <vector>
-
+#include "kdl_export.hpp"
 
 
 namespace KDL {
@@ -29,7 +29,7 @@ namespace KDL {
    * of underlying trajectoria.  Call Add to add a trajectory
    * @ingroup Motion
    */
-class Trajectory_Composite: public Trajectory
+class KDL_EXPORT Trajectory_Composite: public Trajectory
 	{
 		typedef std::vector<Trajectory*> VectorTraj;
 		typedef std::vector<double>         VectorDouble;
diff --git a/orocos_kdl/src/trajectory_segment.hpp b/orocos_kdl/src/trajectory_segment.hpp
index 8d72503..f2f0a41 100644
--- a/orocos_kdl/src/trajectory_segment.hpp
+++ b/orocos_kdl/src/trajectory_segment.hpp
@@ -49,6 +49,7 @@
 #include "trajectory.hpp"
 #include "path.hpp"
 #include "velocityprofile.hpp"
+#include "kdl_export.hpp"
 
 
 namespace KDL {
@@ -59,7 +60,7 @@ namespace KDL {
 	 * trajectory
 	 * @ingroup Motion
 	 */
-	class Trajectory_Segment :  public Trajectory
+	class KDL_EXPORT Trajectory_Segment :  public Trajectory
 	{
 		VelocityProfile* motprof;
 		Path*      geom;
diff --git a/orocos_kdl/src/trajectory_stationary.hpp b/orocos_kdl/src/trajectory_stationary.hpp
index 060b2b0..889e249 100644
--- a/orocos_kdl/src/trajectory_stationary.hpp
+++ b/orocos_kdl/src/trajectory_stationary.hpp
@@ -17,6 +17,7 @@
 #define TRAJECTORY_STATIONARY_H
 
 #include "trajectory.hpp"
+#include "kdl_export.hpp"
 
 
 namespace KDL {
@@ -25,7 +26,7 @@ namespace KDL {
    * for an amount of time.
    * @ingroup Motion
    */
-	class Trajectory_Stationary : public Trajectory
+	class KDL_EXPORT Trajectory_Stationary : public Trajectory
 	  {
 		double duration;
 		Frame pos;
diff --git a/orocos_kdl/src/tree.hpp b/orocos_kdl/src/tree.hpp
index 45f0429..2a504b4 100644
--- a/orocos_kdl/src/tree.hpp
+++ b/orocos_kdl/src/tree.hpp
@@ -24,6 +24,7 @@
 
 #include "segment.hpp"
 #include "chain.hpp"
+#include "kdl_export.hpp"
 
 #include <string>
 #include <map>
@@ -34,7 +35,7 @@ namespace KDL
     class TreeElement;
     typedef std::map<std::string,TreeElement> SegmentMap;
 
-    class TreeElement
+    class KDL_EXPORT TreeElement
     {
     private:
         TreeElement(const std::string& name):segment(name), q_nr(0)
@@ -62,7 +63,7 @@ namespace KDL
      *
      * @ingroup KinematicFamily
      */
-    class Tree
+    class KDL_EXPORT Tree
     {
     private:
         SegmentMap segments;
diff --git a/orocos_kdl/src/treefksolver.hpp b/orocos_kdl/src/treefksolver.hpp
index 3d521d3..ff0f83f 100644
--- a/orocos_kdl/src/treefksolver.hpp
+++ b/orocos_kdl/src/treefksolver.hpp
@@ -31,6 +31,7 @@
 #include "jntarray.hpp"
 //#include "jntarrayvel.hpp"
 //#include "jntarrayacc.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -42,7 +43,7 @@ namespace KDL {
      */
 
     //Forward definition
-    class TreeFkSolverPos {
+    class KDL_EXPORT TreeFkSolverPos {
     public:
         /**
          * Calculate forward position kinematics for a KDL::Tree,
@@ -63,7 +64,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-//    class TreeFkSolverVel {
+//    class KDL_EXPORT TreeFkSolverVel {
 //    public:
         /**
          * Calculate forward position and velocity kinematics, from
@@ -86,7 +87,7 @@ namespace KDL {
      * @ingroup KinematicFamily
      */
 
-//    class TreeFkSolverAcc {
+//    class KDL_EXPORT TreeFkSolverAcc {
 //   public:
         /**
          * Calculate forward position, velocity and accelaration
diff --git a/orocos_kdl/src/treefksolverpos_recursive.hpp b/orocos_kdl/src/treefksolverpos_recursive.hpp
index 14f6450..9e6e6e7 100644
--- a/orocos_kdl/src/treefksolverpos_recursive.hpp
+++ b/orocos_kdl/src/treefksolverpos_recursive.hpp
@@ -24,6 +24,7 @@
 #define KDLTREEFKSOLVERPOS_RECURSIVE_HPP
 
 #include "treefksolver.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -34,7 +35,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class TreeFkSolverPos_recursive : public TreeFkSolverPos
+    class KDL_EXPORT TreeFkSolverPos_recursive : public TreeFkSolverPos
     {
     public:
         TreeFkSolverPos_recursive(const Tree& tree);
diff --git a/orocos_kdl/src/treeiksolver.hpp b/orocos_kdl/src/treeiksolver.hpp
index e6a5200..4526f6b 100644
--- a/orocos_kdl/src/treeiksolver.hpp
+++ b/orocos_kdl/src/treeiksolver.hpp
@@ -11,6 +11,7 @@
 #include "tree.hpp"
 #include "jntarray.hpp"
 #include "frames.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -24,7 +25,7 @@ typedef std::map<std::string, Frame> Frames;
  *
  * @ingroup KinematicFamily
  */
-class TreeIkSolverPos {
+class KDL_EXPORT TreeIkSolverPos {
 public:
     /**
      * Calculate inverse position kinematics, from cartesian
diff --git a/orocos_kdl/src/treeiksolverpos_nr_jl.hpp b/orocos_kdl/src/treeiksolverpos_nr_jl.hpp
index 456e7fa..3f56c10 100644
--- a/orocos_kdl/src/treeiksolverpos_nr_jl.hpp
+++ b/orocos_kdl/src/treeiksolverpos_nr_jl.hpp
@@ -26,6 +26,7 @@
 
 #include "treeiksolver.hpp"
 #include "treefksolver.hpp"
+#include "kdl_export.hpp"
 #include <vector>
 #include <string>
 
@@ -39,7 +40,7 @@ namespace KDL {
  *
  * @ingroup KinematicFamily
  */
-class TreeIkSolverPos_NR_JL: public TreeIkSolverPos {
+class KDL_EXPORT TreeIkSolverPos_NR_JL: public TreeIkSolverPos {
 public:
     /**
      * Constructor of the solver, it needs the tree, a forward
diff --git a/orocos_kdl/src/treeiksolverpos_online.hpp b/orocos_kdl/src/treeiksolverpos_online.hpp
index 7826eb4..6682b92 100644
--- a/orocos_kdl/src/treeiksolverpos_online.hpp
+++ b/orocos_kdl/src/treeiksolverpos_online.hpp
@@ -29,6 +29,7 @@
 #include <string>
 #include "treeiksolver.hpp"
 #include "treefksolver.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -41,7 +42,7 @@ namespace KDL {
  *
  * @ingroup KinematicFamily
  */
-class TreeIkSolverPos_Online: public TreeIkSolverPos {
+class KDL_EXPORT TreeIkSolverPos_Online: public TreeIkSolverPos {
 public:
     /**
      * Constructor of the solver, it needs the number of joints of the tree, a list of the endpoints
diff --git a/orocos_kdl/src/treeiksolvervel_wdls.hpp b/orocos_kdl/src/treeiksolvervel_wdls.hpp
index d268c72..2a5263e 100644
--- a/orocos_kdl/src/treeiksolvervel_wdls.hpp
+++ b/orocos_kdl/src/treeiksolvervel_wdls.hpp
@@ -10,13 +10,14 @@
 
 #include "treeiksolver.hpp"
 #include "treejnttojacsolver.hpp"
+#include "kdl_export.hpp"
 #include <Eigen/Core>
 
 namespace KDL {
 
     using namespace Eigen;
 
-    class TreeIkSolverVel_wdls: public TreeIkSolverVel {
+    class KDL_EXPORT TreeIkSolverVel_wdls: public TreeIkSolverVel {
     public:
         TreeIkSolverVel_wdls(const Tree& tree, const std::vector<std::string>& endpoints);
         virtual ~TreeIkSolverVel_wdls();
diff --git a/orocos_kdl/src/treejnttojacsolver.hpp b/orocos_kdl/src/treejnttojacsolver.hpp
index 84f92ea..c82520f 100644
--- a/orocos_kdl/src/treejnttojacsolver.hpp
+++ b/orocos_kdl/src/treejnttojacsolver.hpp
@@ -11,10 +11,11 @@
 #include "tree.hpp"
 #include "jacobian.hpp"
 #include "jntarray.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
-class TreeJntToJacSolver {
+class KDL_EXPORT TreeJntToJacSolver {
 public:
     explicit TreeJntToJacSolver(const Tree& tree);
 
diff --git a/orocos_kdl/src/utilities/utility.h b/orocos_kdl/src/utilities/utility.h
index 198f3ff..cd05c7a 100644
--- a/orocos_kdl/src/utilities/utility.h
+++ b/orocos_kdl/src/utilities/utility.h
@@ -24,6 +24,7 @@
 #define KDL_UTILITY_H
 
 #include "kdl-config.h"
+#include "kdl_export.hpp"
 #include <cstdlib>
 #include <cassert>
 #include <cmath>
@@ -177,16 +178,16 @@ extern int          STREAMBUFFERSIZE;
 extern int          MAXLENFILENAME;
 
 //! the value of pi
-extern const double PI;
+extern KDL_EXPORT const double PI;
 
 //! the value pi/180
-extern const double deg2rad;
+extern KDL_EXPORT const double deg2rad;
 
 //! the value 180/pi
-extern const double rad2deg;
+extern KDL_EXPORT const double rad2deg;
 
 //! default precision while comparing with Equal(..,..) functions. Initialized at 0.0000001.
-extern double     epsilon;
+extern KDL_EXPORT double     epsilon;
 
 //! the number of derivatives used in the RN-... objects.
 extern int          VSIZE;
diff --git a/orocos_kdl/src/velocityprofile.hpp b/orocos_kdl/src/velocityprofile.hpp
index 827e939..429ac38 100644
--- a/orocos_kdl/src/velocityprofile.hpp
+++ b/orocos_kdl/src/velocityprofile.hpp
@@ -47,7 +47,7 @@
 
 #include "utilities/utility.h"
 #include "utilities/utility_io.h"
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -59,7 +59,7 @@ namespace KDL {
      * in function of time. It defines the how a point s moves on a path S.
      * @ingroup Motion
      */
-class VelocityProfile
+class KDL_EXPORT VelocityProfile
 	{
 	public:
 		// trajectory parameters are set in constructor of
diff --git a/orocos_kdl/src/velocityprofile_dirac.hpp b/orocos_kdl/src/velocityprofile_dirac.hpp
index ce06b6d..a536fd7 100644
--- a/orocos_kdl/src/velocityprofile_dirac.hpp
+++ b/orocos_kdl/src/velocityprofile_dirac.hpp
@@ -30,7 +30,7 @@
 #define MOTIONPROFILE_DIRAC_H
 
 #include "velocityprofile.hpp"
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 	/**
@@ -45,7 +45,7 @@ namespace KDL {
 	 * Duration() == 0;
 	 * @ingroup Motion
 	 */
-	class VelocityProfile_Dirac : public VelocityProfile
+	class KDL_EXPORT VelocityProfile_Dirac : public VelocityProfile
 	{
 		double p1,p2,t;
 	public:
diff --git a/orocos_kdl/src/velocityprofile_rect.hpp b/orocos_kdl/src/velocityprofile_rect.hpp
index 4482779..416d715 100644
--- a/orocos_kdl/src/velocityprofile_rect.hpp
+++ b/orocos_kdl/src/velocityprofile_rect.hpp
@@ -45,7 +45,7 @@
 #define MOTIONPROFILE_RECT_H
 
 #include "velocityprofile.hpp"
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 	/**
@@ -53,7 +53,7 @@ namespace KDL {
 	 * for moving from A to B.
 	 * @ingroup Motion
 	 */
-	class VelocityProfile_Rectangular : public VelocityProfile
+	class KDL_EXPORT VelocityProfile_Rectangular : public VelocityProfile
 		// Defines a rectangular velocityprofile.
 		// (i.e. constant velocity)
 	{
diff --git a/orocos_kdl/src/velocityprofile_spline.hpp b/orocos_kdl/src/velocityprofile_spline.hpp
index 0ce9ea8..2211080 100644
--- a/orocos_kdl/src/velocityprofile_spline.hpp
+++ b/orocos_kdl/src/velocityprofile_spline.hpp
@@ -2,6 +2,7 @@
 #define VELOCITYPROFILE_SPLINE_H
 
 #include "velocityprofile.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
@@ -9,7 +10,7 @@ namespace KDL
 	 * \brief A spline VelocityProfile trajectory interpolation.
 	 * @ingroup Motion
 	 */
-class VelocityProfile_Spline : public VelocityProfile
+class KDL_EXPORT VelocityProfile_Spline : public VelocityProfile
 {
 public:
     VelocityProfile_Spline();
diff --git a/orocos_kdl/src/velocityprofile_trap.hpp b/orocos_kdl/src/velocityprofile_trap.hpp
index a8e1ba0..535c46b 100644
--- a/orocos_kdl/src/velocityprofile_trap.hpp
+++ b/orocos_kdl/src/velocityprofile_trap.hpp
@@ -45,19 +45,16 @@
 #define KDL_MOTION_VELOCITYPROFILE_TRAP_H
 
 #include "velocityprofile.hpp"
-
-
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 
 
-
 	/**
 	 * A Trapezoidal VelocityProfile implementation.
 	 * @ingroup Motion
 	 */
-class VelocityProfile_Trap : public VelocityProfile
+class KDL_EXPORT VelocityProfile_Trap : public VelocityProfile
 	{
 		// For "running" a motion profile :
 		double a1,a2,a3; // coef. from ^0 -> ^2 of first part
diff --git a/orocos_kdl/src/velocityprofile_traphalf.hpp b/orocos_kdl/src/velocityprofile_traphalf.hpp
index fcca324..27317a1 100644
--- a/orocos_kdl/src/velocityprofile_traphalf.hpp
+++ b/orocos_kdl/src/velocityprofile_traphalf.hpp
@@ -47,9 +47,7 @@
 #define KDL_MOTION_VELOCITYPROFILE_TRAPHALF_H
 
 #include "velocityprofile.hpp"
-
-
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -60,7 +58,7 @@ namespace KDL {
 	 * or ending.
 	 * @ingroup Motion
 	 */
-class VelocityProfile_TrapHalf : public VelocityProfile
+class KDL_EXPORT VelocityProfile_TrapHalf : public VelocityProfile
 	{
 		// For "running" a motion profile :
 		double a1,a2,a3; // coef. from ^0 -> ^2 of first part
diff --git a/orocos_kdl/tests/CMakeLists.txt b/orocos_kdl/tests/CMakeLists.txt
index 5d6395a..cd262f7 100644
--- a/orocos_kdl/tests/CMakeLists.txt
+++ b/orocos_kdl/tests/CMakeLists.txt
@@ -1,7 +1,7 @@
 IF(ENABLE_TESTS)
   ENABLE_TESTING()
 
-  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${CPPUNIT_HEADERS})
+  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${PROJ_BINARY_DIR}/src ${CPPUNIT_HEADERS})
 
   ADD_EXECUTABLE(framestest framestest.cpp test-runner.cpp)
   TARGET_LINK_LIBRARIES(framestest orocos-kdl ${CPPUNIT})
